LeetCode: 1. Two Sum

1. 题目

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

2. 解题思路

    暴力解法就是两重循环,时间复杂度为O(n^2),很简单,但提交时会发现超出时间限制。因此,我们需要寻找效率更高的解法。我们想到用hashmap来求解,第一次遍历将数组中的元素存在hashmap中,key值为nums数组元素值,value值为下标值;第二遍循环从前至后遍历数组,如果target-nums[i]在map中存在,就返回这两个数的下标。

    用hashmap求解时,需要注意两个坑:

    1. 数组中可能有重复的元素,此时我们需要进行一次判断,如果target等于重复元素的两倍,那么重复元素所在下标就是我们的解。

    2. 在第二次遍历数组时,有可能会出现,target等于2*某个元素的情况,但题干中不允许用同一个元素两次,因此,我们需要再加上一个判断,即:target!=2*nums[i]。

    具体实现代码如下:

class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        map<int, int> num_map;
        vector<int> res;
        for(int i = 0; i < nums.size(); i++)
        {
            if(num_map.count(nums[i]) == 1)
            {
                if(2*nums[i] == target)
                {
                    res.push_back(num_map[nums[i]]);
                    res.push_back(i);
                    return res;
                }
            }
            num_map[nums[i]] = i;
        }
        for(int i = 0; i < nums.size(); i++)
        {
            if(num_map.count(target-nums[i]) == 1 && target != 2*nums[i])
            {
                res.push_back(num_map[target - nums[i]] < i ? num_map[target-nums[i]] : i);
                res.push_back(num_map[target - nums[i]] > i ? num_map[target-nums[i]] : i);
                return res;
            }
        }
    }
};

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值